<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Plain HTML site using GitLab Pages</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />

    <link rel="stylesheet" href="style.css" />
    <script
      src="https://unpkg.com/@dotlottie/player-component@latest/dist/dotlottie-player.mjs"
      type="module"
    ></script>
  </head>
  <body>
    <section>
      <div class="g">
        <div class="opt" id="opt1">AI Exploration Workshop</div>
        <div class="sep" id="sep1"><div></div></div>
        <div class="opt" id="opt2">Foo bar</div>
        <div class="sep" id="sep2"><div></div></div>
        <div class="opt" id="opt3">Biz baz fuszz</div>
        <div class="sep" id="sep3"><div></div></div>
      </div>
      <div class="p">
        <div class="pic" id="pic1">
          <img src="img/flow1-layer.svg" />
          <dotlottie-player
            src="img/flow1.json"
            background="transparent"
            speed="1"
            direction="1"
            playMode="normal"
          ></dotlottie-player>
        </div>
        <div class="pic" id="pic2">
          <img src="img/flow2-layer.svg" />
          <dotlottie-player
            src="img/flow1.json"
            background="transparent"
            speed="1"
            direction="1"
            playMode="normal"
          ></dotlottie-player>
        </div>
        <div class="pic" id="pic3">
          <img src="img/flow3-layer.svg" />
          <dotlottie-player
            src="img/flow1.json"
            background="transparent"
            speed="1"
            direction="1"
            playMode="normal"
          ></dotlottie-player>
        </div>
      </div>
    </section>

    <script>


      window.onload = () => {
        const DURATION = 4000;
        let currentPic = 1;
        const maxPics = 3;
        let interval;

        let stopAnimation = false;

        function animateWidth(sepElement, duration) {
          let start = null;
          const step = (timestamp) => {
            if (stopAnimation) {
              stopAnimation = false
              return;
            }
            if (!start) start = timestamp;
            const progress = timestamp - start;
            const width = Math.min((progress / duration) * 100, 100);
            sepElement.style.width = width + "%";
            if (progress < duration) {
              window.requestAnimationFrame(step);
            }
          };
          window.requestAnimationFrame(step);
        }

        function showPic(picNumber) {
          for (let i = 1; i <= maxPics; i++) {
            document.getElementById(`pic${i}`).style.display =
              i === picNumber ? "block" : "none";
            document.querySelector(`#pic${i} dotlottie-player`).stop();
            document.querySelector(`#sep${i} > div`).style.width = "0";
          }
          document.querySelector(`#pic${picNumber} dotlottie-player`).play();
          animateWidth(
            document.querySelector(`#sep${picNumber} > div`),
            DURATION
          );
        }

        function resetAndStartTimer() {
          clearInterval(interval);
          showPic(currentPic);


          interval = setInterval(() => {
            stopAnimation = true;
            currentPic = currentPic < maxPics ? currentPic + 1 : 1;
            
            showPic(currentPic);
          }, DURATION);
        }

        document.querySelectorAll(".opt").forEach((opt, index) => {
          opt.addEventListener("click", () => {
            stopAnimation = true;

              currentPic = index + 1;
            resetAndStartTimer();

          });
        });

        resetAndStartTimer();
      };
    </script>
  </body>
</html>
